
//collision.h
//ȊÕIuWFNgm̏Փ˔

void collisionWithRigid(int i, int j, float dt);

void collision(float dt)
{
	int i, j;
	CVector vDir;

	for(i = 0; i < numRigid; i++) 
	{
		rigid[i].action3D(dt);
	}

	if(!flagCollision) return;

	for(i = 0; i < numRigid; i++)
	{ 
		for(j = i+1; j < numRigid; j++) 
		{
			//Wrɂ\
			if(rigid[i].vPos.x + spaceCoord < rigid[j].vPos.x) continue;
			if(rigid[i].vPos.x - spaceCoord > rigid[j].vPos.x) continue;
			if(rigid[i].vPos.y + spaceCoord < rigid[j].vPos.y) continue;
			if(rigid[i].vPos.y - spaceCoord > rigid[j].vPos.y) continue;
			if(rigid[i].vPos.z + spaceCoord < rigid[j].vPos.z) continue;
			if(rigid[i].vPos.z - spaceCoord > rigid[j].vPos.z) continue;

			//Eŗ\
			float d = vDist2(rigid[i].vPos, rigid[j].vPos);//2拗
			float a = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0;
			if(d > a*a) continue;

			collisionWithRigid(i, j, dt);
		}
	}
}

void collisionWithRigid(int i, int j, float dt)
{
  float rikiseki;
  float vn1, vn2;//@̑傫
  float m1, m2;
  CVector vNormal;//ڍ̂猩Փ˖ʂ̖@

	vNormal = rigid[i].vPos >> rigid[j].vPos;//i狅j֌Pʖ@xNg
	float depth = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0 - vDist(rigid[i].vPos, rigid[j].vPos);
	if(depth < 0.0) return;

	//߂荞񂾕
	rigid[i].vPos -= (depth*0.5 + 0.01) * vNormal;			
	rigid[j].vPos += (depth*0.5 + 0.01) * vNormal;

  m1 = rigid[i].mass;
  m2 = rigid[j].mass;

  vn1 = vDot(rigid[i].vVelocity, vNormal);
  vn2 = vDot(rigid[j].vVelocity, vNormal);

  //Փˉ
  //͐
	rikiseki = - (e + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2);//

	rigid[i].vVelocity += (rikiseki * vNormal) / m1;
	rigid[j].vVelocity -= (rikiseki * vNormal) / m2;

	//olɂ镜
	{
		rigid[i].vVelocity +=  - depth * cSpring * vNormal * dt / m1;
		rigid[j].vVelocity +=   depth * cSpring * vNormal * dt / m2;
	}
}
