
//collision.h
//ȊÕIuWFNgm̏Փ˔

void collisionWithRigid(int i, int j, float dt);

void collision(float dt)
{
	int i, j;
	CVector vDir;

	for(i = 0; i < numRigid; i++) 
	{
		rigid[i].action3D(dt);
	}

	if(!flagCollision) return;

	for(i = 0; i < numRigid; i++)
	{ 
		for(j = i+1; j < numRigid; j++) 
		{
			//Wrɂ\
			if(rigid[i].vPos.x + spaceCoord < rigid[j].vPos.x) continue;
			if(rigid[i].vPos.x - spaceCoord > rigid[j].vPos.x) continue;
			if(rigid[i].vPos.y + spaceCoord < rigid[j].vPos.y) continue;
			if(rigid[i].vPos.y - spaceCoord > rigid[j].vPos.y) continue;
			if(rigid[i].vPos.z + spaceCoord < rigid[j].vPos.z) continue;
			if(rigid[i].vPos.z - spaceCoord > rigid[j].vPos.z) continue;

			//Eŗ\
			float d = vDist2(rigid[i].vPos, rigid[j].vPos);//2拗
			float a = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0;
			if(d > a*a) continue;

			collisionWithRigid(i, j, dt);
		}
	}
}

void collisionWithRigid(int i, int j, float dt)
{
  float rikiseki;
  float vn1, vn2;//@̑傫
  float muc, B, m1, m2;
  CVector vVelocityP1, vVelocityP2;//x
  CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
  CVector vDir,vA1, vA2, vRg1, vRg2, vPos1, vPos2;

	vNormal = rigid[i].vPos >> rigid[j].vPos;//i狅j֌Pʖ@xNg
	float depth = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0 - vDist(rigid[i].vPos, rigid[j].vPos);
	if(depth < 0.0) return;

	//߂荞񂾕
	rigid[i].vPos -= (depth*0.5 + 0.01) * vNormal;			
	rigid[j].vPos += (depth*0.5 + 0.01) * vNormal;

	vRg1 = (rigid[i].vSize.x/2.0) * vNormal;
	vRg2 = (rigid[2].vSize.x/2.0) * vNormal.reverse2();

  m1 = rigid[i].mass;
  m2 = rigid[j].mass;
  vVelocityP1 = rigid[i].vVelocity + vCross(rigid[i].vOmega, vRg1);
  vn1 = vDot(vVelocityP1, vNormal);
  vVelocityP2 = rigid[j].vVelocity + vCross(rigid[j].vOmega, vRg2);
  vn2 = vDot(vVelocityP2, vNormal);

  //Փˉ
	//ɑ΂Ă͊ts̓XJƂȂ
	float mInertialInverse1 = 10.0 / (rigid[i].vSize.x * rigid[i].vSize.x * rigid[i].mass);
	float mInertialInverse2 = 10.0 / (rigid[j].vSize.x * rigid[j].vSize.x * rigid[j].mass);
  //͐
  rikiseki = - (e + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2
          + vDot(vNormal , vCross((mInertialInverse1 * vCross(vRg1, vNormal)), vRg1))
          + vDot(vNormal , vCross((mInertialInverse2 * vCross(vRg2, vNormal)), vRg2)));

	rigid[i].vVelocity += (rikiseki * vNormal) / m1;
	rigid[j].vVelocity -= (rikiseki * vNormal) / m2;

	//olɂ镜
	{
		rigid[i].vVelocity +=  - depth * cSpring * vNormal * dt / m1;
		rigid[j].vVelocity +=    depth * cSpring * vNormal * dt / m2;
	}

	//Cl
  //ڐ
  CVector vTangential = vCross( vNormal, vCross((vVelocityP1 - vVelocityP2), vNormal));
  vTangential.norm();
  vA1 = vCross(((mInertialInverse1 * vCross(vRg1, vTangential))) , vRg1);
  vA2 = vCross(((mInertialInverse2 * vCross(vRg2, vTangential))) , vRg2);

  B = - vDot(vTangential, (vVelocityP1-vVelocityP2)) / (1.0f/m1+1.0f/m2+ vDot(vTangential,(vA1+vA2)));
	muc = fabs(B / rikiseki);
//printf("muK=%f, muc=%f \n", muK, muc);
	if(muK >= muc)
	{
		rigid[i].vVelocity +=  vTangential * B / m1;
		rigid[i].vOmega += mInertialInverse1 * vCross(vRg1, vTangential) * B;
		rigid[j].vVelocity -=  vTangential * B / m2;
		rigid[j].vOmega -= mInertialInverse2 * vCross(vRg2, vTangential) * B;
	}
	else
	{
		rigid[i].vVelocity +=  muK * (rikiseki / m1) * vTangential;
		rigid[i].vOmega += mInertialInverse1 * vCross(vRg1, vTangential) * muK * rikiseki;
		rigid[j].vVelocity -=  muK * (rikiseki / m2) * vTangential;
		rigid[j].vOmega -= mInertialInverse2 * vCross(vRg2, vTangential) * muK * rikiseki;
	}
}
