//rigid.h
#include "../../parameters3D.h"

int numRigid = 1000;
int numRigid0 = 100;
//]^
//float speedRotation = 10.0;
//S͌W
float central = 1.0;
//グ
float forceZ = 25.0;
float heightMax = 25.0;
//Wlr̊Ԋu
float spaceCoord = 2.0;

#define RIGID_NUM_MAX 2000
#define MAX_VERTEX 100//ʑ̂̒_ 
#define NON_COLLISION -999;
//-------------------------------------------------------------------------
class CRigid{
public:
	//ޕϐ
	Kind kind;    //CRigid̎
	Color color;  //F
	CVector vSize;//TCY
	CVector vPos; //ʒu
	int pos[3]; //ʒu
	CVector vPosCurrent;//ՓˑÖʒu
	CVector vEuler;//IC[p(p̏ݒ,deg)
	CVector vAxis; //]
	float angle;   //]px(rad)

	//^V~[Vp
	float mass;        //(Kg)
	CVector vForce;    //O(Newton)
	CVector vForce0, vForce1;   //O͏l
	CVector vTorque;   //͂̃[gigN,Newton/mj
	CVector vAccel;    //x(m/s^2)
	CVector vVelocity; //x(m/s)
	CVector vForward;  //is
	CVector vOmega;    //px(rad/s)
	CVector vAlpha;    //px(rad/s^2)
	CVector vGravityToPoint;//dSՓ˓_܂ł̃xNg
	CMatrix mInertia; //[g̃e\
	CMatrix mInertiaInverse;
	CQuaternion q;
    
	//ފ֐
	CRigid();  //RXgN^
	~CRigid(); //fXgN^
	void draw(bool flagShadow);
	//void action2D(float dt);
	void action3D(float dt);
private:

};
CRigid rigid[RIGID_NUM_MAX];

//--------------------------------------------------
CRigid::CRigid()
{
	kind = SPHERE;
	color = WHITE;
  vSize = CVector(1.0, 1.0, 1.0);
  vPos = CVector(0.0, 0.0, 3.0);
	vForce = vForce0 = CVector();
	vVelocity = CVector();
	vOmega = CVector(0.0, 0.0, 0.0);//px(rad)
	vEuler = CVector();
	q = CQuaternion();

	mass = 1.0;
}

//--------------------------------------------------
CRigid::~CRigid()
{
}

//---------------------------------------------------------
void CRigid::draw(bool flagShadow)
{
	//ẽ}eA
	static float shadowDiffuse[] =  {0.0,0.0,0.0,0.3};//e̊gU
	static float shadowSpecular[] = {0.0,0.0,0.0,1.0};//e̋ʌ

	glPushMatrix();
    //݈ʒu
	glTranslatef(vPos.x, vPos.y, vPos.z);//sړ

	//]
	if(q.s > 1.0) q.s = 1.0;
	if(q.s < -1.0) q.s = -1.0;
	angle = 2.0 * acos(q.s);//[rad]
	vAxis = q.v.norm2();
  glRotatef(angle * qq, vAxis.x, vAxis.y, vAxis.z);//]pdegɕϊ

	//̂̃}eA
  static float white0[] = { 0.9, 0.9, 0.9, 1.0};//I
  static float specular[]= { 0.8, 0.8, 0.8, 1.0};
  static float specularS[]= { 0.6, 0.6, 0.6, 1.0};

	if(!flagShadow)
	{
		if(color == RED) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, red);
		if(color == GREEN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, green);
		if(color == BLUE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, blue);
		if(color == YELLOW) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, yellow);
		if(color == CYAN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, cyan);
		if(color == MAGENTA) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, magenta);
		if(color == WHITE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, white);
		if(color == GRAY) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, gray);

		glMaterialfv(GL_FRONT,GL_SPECULAR,specularS);
		glMaterialf(GL_FRONT,GL_SHININESS, 5.0);
	}
	else
	{//e
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
	}

	//XP[O
	glScalef(vSize.x, vSize.y, vSize.z);

	//޼ުĂ̕`
	if(kind == SPHERE || kind == ELLIPSOID) glCallList(sphere);
	else if(kind == CUBE) glCallList(cube);
	else if(kind == CYLINDER) glCallList(cylinder);
	else if(kind == BOX) glCallList(box);
	else if(kind == COLUMN) glCallList(column);
	else if(kind == TORUS) glCallList(torus);
	else if(kind == CONE) glCallList(cone);
	else if(kind == PYRAMID) glCallList(pyramid);
	
	glPopMatrix();
}
//----------------------------------------------------------
void CRigid::action3D(float dt)
{	
	//O͂t^
	float d = vPos.magnitudeXY();//_̐
		if(d > 5.0) 
		{//S
			vForce0 = vPos.normXY2().reverse2() * d * 0.5 ;
		  vForce0.z = 0.0;
		}
		else 
		{
			vForce0 = CVector(0.0, 0.0, forceZ);
		}
		if(vPos.z > heightMax) vForce0.z = 0.0;

	vForce = vForce0 + CVector(0.0, 0.0, -g * mass);
	vVelocity += vForce * dt / mass;


	if(vPos.z < vSize.z / 2.0 && vVelocity.z < 0.0 ) //tAɏՓ
	{
		vVelocity.z = - e * vVelocity.z;
	}
	if(vPos.z < vSize.z / 2.0 + 0.01 && fabs(vVelocity.z) < 0.2)//tA
		vVelocity -= muK * g * vVelocity.normXY2() * dt;

	if(vPos.z < vSize.z / 2.0) vPos.z = vSize.z / 2.0;
	
	vPos += vVelocity * dt;

	q += 0.5 * (vOmega * q) * dt;//Wn
	q.norm();
}
