//bubble.h

#include "../../vesselBox.h"
#include "../../surface.h"

#define RIGID_NUM_MAX 1100
#define POS_NUM_MAX 100//ʒu̍ő吔

int numRigid =1000;// RIGID_NUM_MAX;//q(bubble)
int numPos = POS_NUM_MAX;//CAʒu
int count = 0;//gp̗q
float timer[POS_NUM_MAX];
float startTime[POS_NUM_MAX];
CVector vBubblePos[POS_NUM_MAX];//CAʒu
float interval = 0.5;//CAԊu
float lifetime = 1.0;//CA̎(\Ă鎞ԁj
float bubbleSizeK = 1.0;//̋CATCY̔{
//-------------------------------------------------------------------------
class CRigid{
public:
	//ޕϐ
	Kind kind;    //CRigid̎
	Color color;  //F
	CVector vSize;//TCY
	float bubbleSize;//̋CATCY
	CVector vPos; //ʒu
	//^V~[Vp
	float mass;        //(Kg)
	CVector vForce;    //O(Newton)
	CVector vAccel;    //x(m/s^2)
	CVector vVelocity; //x(m/s)
	bool flagOut;

	float startTime; //ielapseTime2Ōvj
	float time;      //Ă̌oߎ

	//ފ֐
	CRigid();  //RXgN^
	~CRigid(); //fXgN^
	void draw(bool flagShadow);
	void create(int no);
	void action3D(float time, float dt);
};
CRigid rigid[RIGID_NUM_MAX];

//--------------------------------------------------
CRigid::CRigid()
{
	kind = SPHERE;
	color = WHITE;
  vSize = CVector(1.0, 1.0, 1.0);
	bubbleSize = 1.0;
  vPos = CVector(0.0, 0.0, 3.0);
	vForce = CVector();
	vVelocity = CVector();

	mass = 1.0;
	flagOut = false;
}

//--------------------------------------------------
CRigid::~CRigid()
{
}

//---------------------------------------------------------
void CRigid::draw(bool flagShadow)
{
	//ẽ}eA
	static float shadowDiffuse[] =  {0.1, 0.1, 0.1, 0.02};//e̊gU

	glPushMatrix();
    //݈ʒu
	glTranslatef(vPos.x, vPos.y, vPos.z);//sړ
	//̂̃}eA(CAj
	static float diffuse[] = {0.8, 0.8, 1.0, 0.1};
  static float specular[]= {0.9, 0.9, 1.0, 0.9};

	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 100.0);
	}
	else
	{//e
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
	}

	//XP[O
	glScalef(bubbleSize * bubbleSizeK, bubbleSize * bubbleSizeK, bubbleSize * bubbleSizeK) ;

	//޼ުĂ̕`
	if(vPos.z < vesselB.vPos.z - vesselB.vSize.z/2.0 + vesselB.heightFluid + vSize.z) 
	{
		if(!flagOut && time < lifetime) glCallList(sphere);
	}
	
	glPopMatrix();
}
//----------------------------------------------------------
void CRigid::create(int n)
{
	vPos = vBubblePos[n];
	vVelocity = CVector(getRandom(-5.0, 5.0), getRandom(-5.0, 5.0), getRandom(10.0, 20.0));
	bubbleSize = getRandom(0.8, 1.2);//̃TCY
	vSize = CVector(spaceCoord, spaceCoord, spaceCoord);//tʗqƂ̏Փ˂ɎgTCY͌Œ
}
//----------------------------------------------------------
void CRigid::action3D(float time, float dt)
{	
	if(!flagOut)
	{
		if(vPos.z < vesselB.vPos.z - vesselB.vSize.z/2.0 + vesselB.heightFluid)
		{
			vVelocity.z +=- (g - buoyant / mass) * dt ;
		}
		else
		{
			 vVelocity = CVector();//tʂɌŒ
		}
	}

	vPos += vVelocity * dt;
}


