
//collision.h
//Փ˂ɊւTu[`

void collisionWithRigid(int i, int j, float dt);
void collisionWithVessel(float dt);
void collisionWithSurface(float dt);

void collision(float dt)
{
	int i, j;
	CVector vDir;

	for(i = 0; i < numRigid; i++) 
	{
		rigid[i].action3D(dt);
	}

	for(i = 0; i < numRigid; i++)
	{ 
		for(j = i+1; j < numRigid; j++) 
		{
			//Wrɂ\
			if(rigid[i].vPos.x + spaceCoord < rigid[j].vPos.x) continue;
			if(rigid[i].vPos.x - spaceCoord > rigid[j].vPos.x) continue;
			if(rigid[i].vPos.y + spaceCoord < rigid[j].vPos.y) continue;
			if(rigid[i].vPos.y - spaceCoord > rigid[j].vPos.y) continue;
			if(rigid[i].vPos.z + spaceCoord < rigid[j].vPos.z) continue;
			if(rigid[i].vPos.z - spaceCoord > rigid[j].vPos.z) continue;
			//Eŗ\
			float d = vDist2(rigid[i].vPos, rigid[j].vPos);//2拗
			float a = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0;
			if(d > a*a) continue;

			collisionWithRigid(i, j, dt);
		}
	}

	collisionWithVessel(dt);
	collisionWithSurface(dt);

}

void collisionWithRigid(int i, int j, float dt)
{
  float rikiseki;
  float vn1, vn2;//@̑傫
  float m1, m2;

	CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
  CVector vTangential;//ڐ
  CVector vDir,vA1, vA2, vRg1, vRg2, vPos1, vPos2;

	vNormal = rigid[i].vPos >> rigid[j].vPos;//i狅j֌Pʖ@xNg
	float depth = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0 - vDist(rigid[i].vPos, rigid[j].vPos);

	if(depth < 0.0) return;

	//߂荞񂾕
	rigid[i].vPos -= (depth*0.5) * vNormal;			
	rigid[j].vPos += (depth*0.5) * vNormal;

  m1 = rigid[i].mass;
  m2 = rigid[j].mass;

  vn1 = vDot(rigid[i].vVelocity, vNormal);
  vn2 = vDot(rigid[j].vVelocity, vNormal);

  //Փˉ
  //͐
	rikiseki = - (e + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2);//

	rigid[i].vVelocity += (rikiseki * vNormal) / m1;
	rigid[j].vVelocity -= (rikiseki * vNormal) / m2;

	//olɂ镜
	{
		rigid[i].vVelocity +=  - depth * cSpring * vNormal * dt / m1;
		rigid[j].vVelocity +=   depth * cSpring * vNormal * dt / m2;
	}
}

void collisionWithVessel(float dt)
{
	CVector v_pos, v_vel;
	float depth;

	//ǂƂ̏Փ
	for(int i = 0; i < numRigid; i++)
	{ 
		//̈O
		//qW,xǋE{bNX̊{Wnɕϊ
		v_pos = qvRotate(~vesselB.q, rigid[i].vPos - vesselB.vPos);
		v_vel = qvRotate(~vesselB.q, rigid[i].vVelocity);

		if(v_pos.x < -vesselB.widthX/2.0 || v_pos.x > vesselB.widthX/2.0 ||
		   v_pos.y < -vesselB.widthY/2.0 || v_pos.y > vesselB.widthY/2.0 ||
			 v_pos.z < -vesselB.widthZ/2.0 || v_pos.z > vesselB.widthZ/2.0) 
		{
			rigid[i].flagOut = true; //rigid[i].color = RED;
			if(vesselB.flagClose)
			{//Iɓɕ߂
				v_pos.x = getRandom(-vesselB.widthX/2.0+2.0, vesselB.widthX/2.0-2.0);
				v_pos.y = getRandom(-vesselB.widthY/2.0+2.0, vesselB.widthY/2.0-2.0);
				v_pos.z = getRandom(-vesselB.widthZ/2.0+2.0, vesselB.widthZ/2.0-2.0);
			}
			else continue;
		}
		else rigid[i].flagOut = false;

		for(int j = 0; j < vesselB.numSide; j++) 
		{
			float a = rigid[i].vSize.x / 2.0 + vesselB.thickness / 2.0;
			if(j == 0)//̕
			{	
				depth = -vesselB.widthX/2.0 - v_pos.x + a;
				if(depth < 0.0) continue;
				v_vel.x *= -e;//xx𔽓]
				v_vel.x += depth * cSpring * dt / rigid[i].mass;
				v_pos.x += depth;//߂荞񂾕ǂ
			}
			else if(j == 1)//
			{	
				depth = -vesselB.widthY/2.0 - v_pos.y + a;
				if(depth < 0.0) continue;
				v_vel.y *= -e;//xx𔽓]
				v_vel.y += depth * cSpring * dt / rigid[i].mass;
				v_pos.y += depth;//߂荞񂾕ǂ
			}
			else if(j == 2)//E
			{	
				depth = v_pos.y + a - vesselB.widthY/2.0;
				if(depth < 0.0) continue;
				v_vel.y *= -e;//xx𔽓]
				v_vel.y -= depth * cSpring * dt / rigid[i].mass;
				v_pos.y -= depth;//߂荞񂾕ǂ
			}
			else if(j == 3)//O
			{	
				depth = v_pos.x + a - vesselB.widthX/2.0;
				if(depth < 0.0) continue;
				v_vel.x *= -e;//xx𔽓]
				v_vel.x -= depth * cSpring * dt / rigid[i].mass;
				v_pos.x -= depth;//߂荞񂾕ǂ
			}
			else if(j == 4)//
			{	
				depth = -vesselB.widthZ/2.0 - v_pos.z + a;
				if(depth < 0.0) continue;
				v_vel.z *= -e ;//xx𔽓]
				v_vel.z += depth * cSpring * dt / rigid[i].mass;
				v_pos.z += depth;//߂荞񂾕ǂ
			}
			else if(j == 5)//
			{	if(!vesselB.flagCover) continue;
				depth = v_pos.z + a - vesselB.widthZ/2.0;
				if(depth < 0.0) continue;
				v_vel.z *= -e;//xx𔽓]
				v_vel.z += depth * cSpring * dt / rigid[i].mass;
				v_pos.z -= depth;//߂荞񂾕ǂ
			}
		}
		//̐EWnɖ߂
		rigid[i].vPos = qvRotate(vesselB.q, v_pos) + vesselB.vPos;
		rigid[i].vVelocity = qvRotate(vesselB.q, v_vel);
	}
}

void collisionWithSurface(float dt)
{
	int i, j, k; 
  float rikiseki;
  float vn1, vn2;//@̑傫
  float m1, m2;

	CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
  CVector vTangential;//ڐ
  CVector vDir,vA1, vA2, vRg1, vRg2, vPos1, vPos2;

	for(i = 0; i < surface.numRow; i++)
			for(j = 0; j < surface.numCol; j++)
        surface.point[i][j].vForce = CVector();

	//tʗqƂ̏Փ
	for(k = 0; k < numRigid; k++)
	{
		if(rigid[k].flagOut) continue;
		if(rigid[k].vVelocity.magnitude() < 5.0) continue;//͂Ȃ葬xƂ
	                                                    //ʏ̍̂𗎂Ƃ

		for(i = 0; i < surface.numRow; i++)
		{
			for(j = 0; j < surface.numCol; j++)
			{ 
				//Wrɂ\
				if(rigid[k].vPos.x + spaceCoord < surface.point[i][j].vPos.x) continue;
				if(rigid[k].vPos.x - spaceCoord > surface.point[i][j].vPos.x) continue;
				if(rigid[k].vPos.y + spaceCoord < surface.point[i][j].vPos.y) continue;
				if(rigid[k].vPos.y - spaceCoord > surface.point[i][j].vPos.y) continue;
				if(rigid[k].vPos.z + spaceCoord < surface.point[i][j].vPos.z) continue;
				if(rigid[k].vPos.z - spaceCoord > surface.point[i][j].vPos.z) continue;

			//Eŗ\
				float d = vDist2(rigid[k].vPos, surface.point[i][j].vPos);//2拗
				float a = (rigid[k].vSize.x + surface.point[i][j].vSize.x) / 2.0;
				if(d > a*a) continue;

				vNormal = rigid[k].vPos >> surface.point[i][j].vPos;//k狅ij֌Pʖ@xNg
				float depth = (rigid[k].vSize.x + surface.point[i][j].vSize.x) / 2.0 - vDist(rigid[k].vPos, surface.point[i][j].vPos);

				if(depth < 0.0) continue;//return;

				//߂荞񂾕
				rigid[k].vPos -= (depth*0.5) * vNormal;			
				surface.point[i][j].vPos += (depth*0.5) * vNormal;

				m1 = rigid[k].mass;
				m2 = surface.point[i][j].mass;

				vn1 = vDot(rigid[k].vVelocity, vNormal);
				vn2 = vDot(surface.point[i][j].vVelocity, vNormal);

				//Փˉ
				//͐
				rikiseki = - (e + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2);//

				rigid[k].vVelocity += (rikiseki * vNormal) / m1;
				surface.point[i][j].vVelocity -= (rikiseki * vNormal) / m2;
 			}//j
		}//i
	}//k

}

