//rigid.h

#include "../../vesselBox.h"
#include "../../surface.h"

int numRigid = 1000;//q()

#define RIGID_NUM_MAX 1000

//-------------------------------------------------------------------------
class CRigid{
public:
	//ޕϐ
	Kind kind;    //CRigid̎
	Color color;  //F
	CVector vSize;//TCY
	CVector vPos; //ʒu

	//^V~[Vp
	float mass;        //(Kg)
	CVector vForce;    //O(Newton)
	CVector vAccel;    //x(m/s^2)
	CVector vVelocity; //x(m/s)

	bool flagOut;

	//ފ֐
	CRigid();  //RXgN^
	~CRigid(); //fXgN^
	void draw(bool flagShadow);
	void action3D(float dt);
};
CRigid rigid[RIGID_NUM_MAX];

//--------------------------------------------------
CRigid::CRigid()
{
	kind = SPHERE;
	color = WHITE;
  vSize = CVector(1.0, 1.0, 1.0);
  vPos = CVector(0.0, 0.0, 3.0);
	vForce = CVector();
	vVelocity = CVector();

	mass = 1.0;
	flagOut = false;
}

//--------------------------------------------------
CRigid::~CRigid()
{
}

//---------------------------------------------------------
void CRigid::draw(bool flagShadow)
{
	//ẽ}eA
	static float shadowDiffuse[] =  {0.0, 0.0, 0.0, 0.2};//e̊gU

	glPushMatrix();
    //݈ʒu
	glTranslatef(vPos.x, vPos.y, vPos.z);//sړ
	//̂̃}eA
  static float specular[]= { 0.8, 0.8, 0.8, 1.0};
  static float specularS[]= { 0.6, 0.6, 0.6, 1.0};

	if(!flagShadow)
	{
		if(color == RED) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, red);
		if(color == GREEN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, green);
		if(color == BLUE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, blue);
		if(color == YELLOW) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, yellow);
		if(color == CYAN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, cyan);
		if(color == MAGENTA) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, magenta);
		if(color == WHITE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, white);
		if(color == GRAY) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, gray);

		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 20.0);
	}
	else
	{//e
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
	}

	//XP[O
	glScalef(vSize.x, vSize.y, vSize.z);

	//޼ުĂ̕`
	if(kind == SPHERE) glCallList(sphere);
	else if(kind == CUBE) glCallList(cube);
	else if(kind == CYLINDER) glCallList(cylinder);
	else if(kind == BOX) glCallList(box);
	else if(kind == COLUMN) glCallList(column);
	
	glPopMatrix();
}

//----------------------------------------------------------
void CRigid::action3D(float dt)
{	
	//Ό̌_ɌŒ

	if(!flagOut)
	{
		if(vPos.z < vesselB.vPos.z - vesselB.vSize.z/2.0 + vesselB.heightFluid)
		{//tʈȉ̗q

			if(vPos.magnitudeXY() < 5.0) 
				vVelocity.z += - (g - buoyant / mass) * dt;

			else
				vVelocity.z += - (g  - buoyant * 0.1/ mass) * dt;

			if(vPos.z < vesselB.vPos.z - vesselB.vSize.z/2 + vesselB.heightFluid / 2.0)
				vVelocity -= vPos.normXY2() * 0.01 * buoyant / mass;//̗
			else 
				vVelocity += vPos.normXY2() * 0.01 * buoyant / mass;//O̗

			//tʈȉ̗qɑ΂ĔSR
			vVelocity -= viscous * vVelocity * dt / mass;//SR
		}
		else
			vVelocity.z += - g * dt;

	}

	else//eO
	{
		vVelocity.z += - g * dt;

		if(vPos.z < vSize.z / 2.0 && vVelocity.z < 0.0 ) //tAɏՓ
		{
			vVelocity.z = - e * vVelocity.z;
		}
		if(vPos.z < vSize.z / 2.0 + 0.01 && fabs(vVelocity.z) < 0.2)//tA
			vVelocity -= muK * g * vVelocity.normXY2() * dt;

		if(vPos.z < vSize.z / 2.0) vPos.z = vSize.z / 2.0;
	}

	vPos += vVelocity * dt;
}

