
//collision.h
//Փ˂ɊւTu[`

void collisionWithRigid(int i, int j, float dt);
void collisionWithVesselC(float dt);

void collision(float dt)
{
	int i, j;
	CVector vDir;

	for(i = 0; i < numRigid; i++) 
	{
		rigid[i].action3D(dt);
	}

	for(i = 0; i < numRigid; i++)
	{ 
		for(j = i+1; j < numRigid; j++) 
		{
			//Wrɂ\
			if(rigid[i].vPos.x + spaceCoord < rigid[j].vPos.x) continue;
			if(rigid[i].vPos.x - spaceCoord > rigid[j].vPos.x) continue;
			if(rigid[i].vPos.y + spaceCoord < rigid[j].vPos.y) continue;
			if(rigid[i].vPos.y - spaceCoord > rigid[j].vPos.y) continue;
			if(rigid[i].vPos.z + spaceCoord < rigid[j].vPos.z) continue;
			if(rigid[i].vPos.z - spaceCoord > rigid[j].vPos.z) continue;
			//Eŗ\
			float d = vDist(rigid[i].vPos, rigid[j].vPos) ;//
			float a = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0;
			if(d > a) continue;

			collisionWithRigid(i, j, dt);
		}
	}

	collisionWithVesselC(dt);

}

void collisionWithRigid(int i, int j, float dt)
{
  float rikiseki;
  float vn1, vn2;//@̑傫
  float m1, m2;

	CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
  CVector vTangential;//ڐ
  CVector vDir,vA1, vA2, vRg1, vRg2, vPos1, vPos2;

	vNormal = rigid[i].vPos >> rigid[j].vPos;//i狅j֌Pʖ@xNg
	float depth = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0 - vDist(rigid[i].vPos, rigid[j].vPos);
	if(depth < 0.0) return
	//߂荞񂾕
	rigid[i].vPos -= (depth*0.5) * vNormal;			
	rigid[j].vPos += (depth*0.5) * vNormal;

  m1 = rigid[i].mass;
  m2 = rigid[j].mass;

  vn1 = vDot(rigid[i].vVelocity, vNormal);
  vn2 = vDot(rigid[j].vVelocity, vNormal);

  //Փˉ
  //͐
	rikiseki = - (e + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2);//

	rigid[i].vVelocity += (rikiseki * vNormal) / m1;
	rigid[j].vVelocity -= (rikiseki * vNormal) / m2;

	//olɂ镜
	{
		rigid[i].vVelocity +=  - depth * cSpring * vNormal * dt / m1;
		rigid[j].vVelocity +=  + depth * cSpring * vNormal * dt / m2;
	}
}
//----------------------------------------------------------------------------------
void collisionWithVesselC(float dt)
{
	CVector v_pos, v_vel, v_normal, v_accelC, v_accelG, v_koten, v_velT, v_omega;
	float depth;

	//vessel̊{Wnɂpx
	v_omega = qvRotate(~vesselC.q, vesselC.vOmega);
	//vessel̉]
	CVector v_axis = v_omega.norm2();

	float omega = v_omega.magnitude();

	for(int i = 0; i < numRigid; i++)
	{ 
		if(rigid[i].flagOutCover) continue;//Woq͏
		//qW,xe̊{Wnɕϊ
		v_pos = qvRotate(~vesselC.q, rigid[i].vPos - vesselC.vPos);
		v_vel = qvRotate(~vesselC.q, rigid[i].vVelocity);//e͐Î~Ԃ
		//̂v_axis]ɍ~낵̌_
		v_koten = v_axis * vDot(v_axis, v_pos);
		//vessel̉]ɂڐ̑x
		v_velT = vCross(v_omega, v_pos - v_koten);
		v_accelC = (v_koten - v_pos) * omega * omega;//Sx
		v_accelG = qvRotate(~vesselC.q, CVector(0.0, 0.0, -g)) - v_accelC;//Ld͉x

		//O
		if(v_pos.magnitudeXY() > vesselC.radius || v_pos.z < -vesselC.height/2.0 || v_pos.z > vesselC.height/2.0)
		{
			rigid[i].flagOut = true;
		}
		else rigid[i].flagOut = false;

		if(vesselC.flagCover)//W
		{
			if(rigid[i].flagOut)
			{
				if(vesselC.flagClose)
				{//Iɓɕ߂
					v_pos = getRandomVectorXY() * (vesselC.radius - 2.0);
					v_pos.z = getRandom(-vesselC.height/2.0+2.0, vesselC.height/2.0-5.0);
				}
				else {rigid[i].flagOut = true; continue;}
			}
			else rigid[i].flagOut = false;
		}
		else//WȂ
		{	//ꂩoq͕߂Ȃ
			if(v_pos.z > vesselC.height/2.0) {rigid[i].flagOutCover = true; continue; }
			else
			{
				if(v_pos.z < vesselC.height/2.0 && (v_pos.magnitudeXY() > vesselC.radius || v_pos.z < -vesselC.height/2.0))
				{
					if(vesselC.flagClose)
					{//Iɓɕ߂
						v_pos = getRandomVectorXY() * (vesselC.radius - 2.0);
						v_pos.z = getRandom(-vesselC.height/2.0+2.0, vesselC.height/2.0-5.0);
					}
					else {rigid[i].flagOut = true; continue;}
				}
			}
		}

		//ʂƂ̏Փ
		float ng;
		float a = rigid[i].vSize.x / 2.0 + vesselC.thickness / 2.0;
		depth = v_pos.magnitudeXY() + a - vesselC.radius;
		if(depth > 0.0)
		{
			v_normal = v_pos.normXY2();
			v_vel += -(e + 1.0) * vDot(v_vel, v_normal) * v_normal;
			v_vel -= depth * cSpring * v_normal * dt /  rigid[i].mass;
			v_pos -= depth * v_normal;//߂荞񂾕ǂ
			//C̉e
			ng = vDot(v_pos.normXY2(), v_accelG);
			if(ng > 0.0) v_vel -= muK * ng * (v_vel-v_velT).norm2() * dt;
		}
		
		//ƏՓ
		depth = -vesselC.height/2.0 - v_pos.z + a;
		if(depth > 0.0)
		{
			v_vel.z *= -e ;//xz𔽓]
			v_vel.z += depth * cSpring * dt / rigid[i].mass;
			v_pos.z += depth;//߂荞񂾕ǂ
			//C̉eixyʁj
			ng = vDot(CVector(0.0, 0.0, -1.0), v_accelG);
			if(ng > 0.0) v_vel -= muK * ng * (v_vel-v_velT).normXY2() * dt;
		}
		
		//Ƃ̏Փ
		if(vesselC.flagCover) 
		{
			depth = v_pos.z + a - vesselC.height/2.0;
			if(depth > 0.0) 
			{
				v_vel.z *= -e;//xz𔽓]
				v_vel.z += depth * cSpring * dt / rigid[i].mass;
				v_pos.z -= depth;//߂荞񂾕ǂ
				//C̉eixyʁj
				ng = vDot(CVector(0.0, 0.0, 1.0), v_accelG);
				if(ng > 0.0) v_vel -= muK * ng * (v_vel - v_velT).normXY2() * dt;
			}
		}

		//̐EWnɖ߂
		rigid[i].vPos = qvRotate(vesselC.q, v_pos) + vesselC.vPos;
		rigid[i].vVelocity = qvRotate(vesselC.q, v_vel);
	}
}
