
//collision.h
//Փ˂ɊւTu[`

void collisionWithRigid(int i, int j, float dt);
void collisionWithVesselB(float dt);
void collisionWithVesselC(float dt);

void collision(float dt)
{
	int i, j;
	CVector vDir;

	for(i = 0; i < numRigid; i++) 
	{
		rigid[i].action3D(dt);
	}

	for(i = 0; i < numRigid; i++)
	{ 
		for(j = i+1; j < numRigid; j++) 
		{
			//Wrɂ\
			if(rigid[i].vPos.x + spaceCoord < rigid[j].vPos.x) continue;
			if(rigid[i].vPos.x - spaceCoord > rigid[j].vPos.x) continue;
			if(rigid[i].vPos.y + spaceCoord < rigid[j].vPos.y) continue;
			if(rigid[i].vPos.y - spaceCoord > rigid[j].vPos.y) continue;
			if(rigid[i].vPos.z + spaceCoord < rigid[j].vPos.z) continue;
			if(rigid[i].vPos.z - spaceCoord > rigid[j].vPos.z) continue;
			//Eŗ\
			float d = vDist2(rigid[i].vPos, rigid[j].vPos);//2拗
			float a = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0;
			if(d > a*a) continue;

			collisionWithRigid(i, j, dt);
		}
	}

	collisionWithVesselB(dt);
	collisionWithVesselC(dt);

}

void collisionWithRigid(int i, int j, float dt)
{
  float rikiseki;
  float vn1, vn2;//@̑傫
  float m1, m2;
	float dd = 0.01;//߂荞ݕ߂Ƃ̏悹

	CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
  CVector vTangential;//ڐ
  CVector vDir,vA1, vA2, vRg1, vRg2, vPos1, vPos2;

	vNormal = rigid[i].vPos >> rigid[j].vPos;//i狅j֌Pʖ@xNg
	float depth = (rigid[i].vSize.x + rigid[j].vSize.x) / 2.0 - vDist(rigid[i].vPos, rigid[j].vPos);

	if(depth < 0.0) return;

	//߂荞񂾕
	rigid[i].vPos -= (depth*0.5 + dd) * vNormal;			
	rigid[j].vPos += (depth*0.5 + dd) * vNormal;

  m1 = rigid[i].mass;
  m2 = rigid[j].mass;

  vn1 = vDot(rigid[i].vVelocity, vNormal);
  vn2 = vDot(rigid[j].vVelocity, vNormal);

  //Փˉ
  //͐
	rikiseki = - (e + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2);//

	rigid[i].vVelocity += (rikiseki * vNormal) / m1;
	rigid[j].vVelocity -= (rikiseki * vNormal) / m2;

	//olɂ镜
	{
		rigid[i].vVelocity +=  - depth * cSpring * vNormal * dt / m1;
		rigid[j].vVelocity +=   depth * cSpring * vNormal * dt / m2;
	}
}

//----------------------------------------------------------------------
void collisionWithVesselB(float dt)
{
	CVector v_pos, v_vel;
	float depth;

	for(int i = 0; i < numRigid; i++)
	{ 
		//qW,xvessel̊{Wnɕϊ
		v_pos = qvRotate(~vesselB.q, rigid[i].vPos - vesselB.vPos);
		v_vel = qvRotate(~vesselB.q, rigid[i].vVelocity);
		//d͉xvessel̊{Wnɕϊ
		CVector v_accelG = qvRotate(~vesselB.q, CVector(0.0, 0.0, -g));

		//̈O
		if(v_pos.x < -vesselB.widthX/2.0 || v_pos.x > vesselB.widthX/2.0 ||
			 v_pos.y < -vesselB.widthY/2.0 || v_pos.y > vesselB.widthY/2.0 ||
			 v_pos.z < -vesselB.widthZ/2.0 || v_pos.z > vesselB.widthZ/2.0) 
		{
			rigid[i].flagOutB = true; 
		}
		else rigid[i].flagOutB = false;

		//eʂƂ̏Փ
		float ng;
		float dd = 0.01;//߂荞ݕ߂Ƃ̏悹
		float a = rigid[i].vSize.x / 2.0 + vesselB.thickness / 2.0;

		for(int j = 0; j < vesselB.numSide; j++) 
		{
			if(j <= 3 && (v_pos.z < -vesselB.widthZ/2.0 || v_pos.z > vesselB.widthZ/2.0)) continue;
			if(j >= 4 && (v_pos.x < -vesselB.widthX/2.0 || v_pos.x > vesselB.widthX/2.0 ||
										v_pos.y < -vesselB.widthY/2.0 || v_pos.y > vesselB.widthY/2.0 )) continue;
			if(j == 0)//̕
			{
				if(v_pos.y < -vesselB.widthY/2.0 || v_pos.y > vesselB.widthY/2.0 ) continue;
				if(v_pos.x > -vesselB.widthX/2.0) 
				{//
					depth = -vesselB.widthX/2.0 - v_pos.x + a;
					if(depth < 0.0) continue;
					v_vel.x *= -e;//xx𔽓]
					v_vel.x += depth * cSpring * dt / rigid[i].mass;
					v_pos.x += depth+dd;//߂荞񂾕ǂ
					//C̉eiyzʁj
					ng = vDot(CVector(-1.0, 0.0, 0.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normYZ2() * dt;
				}
				else
				{//O
					depth =  vesselB.widthX/2.0 + v_pos.x + a;
					if(depth < 0.0) continue;
					v_vel.x *= -e;//xx𔽓]
					v_vel.x -= depth * cSpring * dt / rigid[i].mass;
					v_pos.x -= depth;//߂荞񂾕ǂ
					//C̉eiyzʁj
					ng = vDot(CVector(1.0, 0.0, 0.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normYZ2() * dt;
				}
			}
			else if(j == 1)//
			{	
				if(v_pos.x < -vesselB.widthX/2.0 || v_pos.x > vesselB.widthX/2.0) continue;
				if(v_pos.y > -vesselB.widthY/2.0)
				{//
					depth = -vesselB.widthY/2.0 - v_pos.y + a;
					if(depth < 0.0) continue;
					v_vel.y *= -e;//xx𔽓]
					v_vel.y += depth * cSpring * dt / rigid[i].mass;
					v_pos.y += depth+dd;//߂荞񂾕ǂ
					//C̉eixzʁj
					ng = vDot(CVector(0.0, -1.0, 0.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normXZ2() * dt;
				}
				else
				{//O
					depth = vesselB.widthY/2.0 + v_pos.y + a;
					if(depth < 0.0) continue;
					v_vel.y *= -e;//xy𔽓]
					v_vel.y -= depth * cSpring * dt / rigid[i].mass;
					v_pos.y -= depth;//߂荞񂾕ǂ
					//C̉eixzʁj
					ng = vDot(CVector(0.0, 1.0, 0.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normXZ2() * dt;
				}
			}
			else if(j == 2)//E
			{	
				if(v_pos.x < -vesselB.widthX/2.0 || v_pos.x > vesselB.widthX/2.0) continue;
				if(v_pos.y < vesselB.widthY/2.0)
				{//
					depth = v_pos.y + a - vesselB.widthY/2.0;
					if(depth < 0.0) continue;
					v_vel.y *= -e;//xx𔽓]
					v_vel.y -= depth * cSpring * dt / rigid[i].mass;
					v_pos.y -= depth+dd;//߂荞񂾕ǂ
					//C̉eixzʁj
					ng = vDot(CVector(0.0, 1.0, 0.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normXZ2() * dt;
				}
				else
				{//O
					depth = -v_pos.y + a + vesselB.widthY/2.0;
					if(depth < 0.0) continue;
					v_vel.y *= -e;//xy𔽓]
					v_vel.y += depth * cSpring * dt / rigid[i].mass;
					v_pos.y += depth;//߂荞񂾕ǂ
					//C̉eixzʁj
					ng = vDot(CVector(0.0, -1.0, 0.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normXZ2() * dt;
				}
			}
			else if(j == 3)//O
			{	
				if(v_pos.y < -vesselB.widthY/2.0 || v_pos.y > vesselB.widthY/2.0 ) continue;
				if(v_pos.x < vesselB.widthX / 2.0)
				{
					depth = v_pos.x + a - vesselB.widthX/2.0;
					if(depth < 0.0) continue;
					v_vel.x *= -e;//xx𔽓]
					v_vel.x -= depth * cSpring * dt / rigid[i].mass;
					v_pos.x -= depth+dd;//߂荞񂾕ǂ
					//C̉eiyzʁj
					ng = vDot(CVector(1.0, 0.0, 0.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normYZ2() * dt;
				}
				else
				{
					depth = -v_pos.x + a + vesselB.widthX/2.0;
					if(depth < 0.0) continue;
					v_vel.x *= -e;//xx𔽓]
					v_vel.x += depth * cSpring * dt / rigid[i].mass;
					v_pos.x += depth;//߂荞񂾕ǂ
					//C̉eiyzʁj
					ng = vDot(CVector(-1.0, 0.0, 0.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normYZ2() * dt;
				}
			}
			else if(j == 4)//
			{	
				if(v_pos.z > -vesselB.widthZ/2.0)
				{
					depth = -vesselB.widthZ/2.0 - v_pos.z + a;
					if(depth < 0.0) continue;
					v_vel.z *= -e ;//xx𔽓]
					v_vel.z += depth * cSpring * dt / rigid[i].mass;
					v_pos.z += depth+dd;//߂荞񂾕ǂ
					//C̉eixyʁj
					ng = vDot(CVector(0.0, 0.0, -1.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normXY2() * dt;
				}
				else
				{
					depth = vesselB.widthZ/2.0 + v_pos.z + a;
					if(depth < 0.0) continue;
					v_vel.z *= -e ;//xx𔽓]
					v_vel.z -= depth * cSpring * dt / rigid[i].mass;
					v_pos.z -= depth;//߂荞񂾕ǂ
					//C̉eixyʁj
					ng = vDot(CVector(0.0, 0.0, 1.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normXY2() * dt;
				}
			}
			else if(j == 5)//
			{
				if(!vesselB.flagCover) continue;
				if(v_pos.z < vesselB.widthZ/2.0)
				{
					depth = v_pos.z + a - vesselB.widthZ/2.0;
					if(depth < 0.0) continue;
					v_vel.z *= -e;//xx𔽓]
					v_vel.z -= depth * cSpring * dt / rigid[i].mass;
					v_pos.z -= depth+dd;//߂荞񂾕ǂ
					//C̉eixyʁj
					ng = vDot(CVector(0.0, 0.0, 1.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normXY2() * dt;
				}
				else
				{
					depth = -v_pos.z + a + vesselB.widthZ/2.0;
					if(depth < 0.0) continue;
					v_vel.z *= -e;//xx𔽓]
					v_vel.z += depth * cSpring * dt / rigid[i].mass;
					v_pos.z += depth+dd;//߂荞񂾕ǂ
					//C̉eixyʁj
					ng = vDot(CVector(0.0, 0.0, -1.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * v_vel.normXY2() * dt;
				}
			}
		}
		//̐EWnɖ߂
		rigid[i].vPos = qvRotate(vesselB.q, v_pos) + vesselB.vPos;
		rigid[i].vVelocity = qvRotate(vesselB.q, v_vel);
	}
}

//----------------------------------------------------------------------------------
void collisionWithVesselC(float dt)
{
	CVector v_pos, v_vel, v_normal, v_accelC, v_accelG, v_koten, v_velT, v_omega;
	float depth;
	float dd = 0.01;//߂荞ݕ߂Ƃ̏悹

	//vessel̊{Wnɂpx
	v_omega = qvRotate(~vesselC.q, vesselC.vOmega);
	//vessel̉]
	CVector v_axis = v_omega.norm2();

	float omega = v_omega.magnitude();

	for(int i = 0; i < numRigid; i++)
	{ 
		//qW,xe̊{Wnɕϊ
		v_pos = qvRotate(~vesselC.q, rigid[i].vPos - vesselC.vPos);
		v_vel = qvRotate(~vesselC.q, rigid[i].vVelocity);//e͐Î~Ԃ
		//̂v_axis]ɍ~낵̌_
		v_koten = v_axis * vDot(v_axis, v_pos);
		//vessel̉]ɂڐ̑x
		v_velT = vCross(v_omega, v_pos - v_koten);
		v_accelC = (v_koten - v_pos) * omega * omega;//Sx
		v_accelG = qvRotate(~vesselC.q, CVector(0.0, 0.0, -g)) - v_accelC;//Ld͉x

		if(v_pos.magnitudeXY() > vesselC.radius || v_pos.z < -vesselC.height/2.0 || v_pos.z > vesselC.height/2.0)
		{
			rigid[i].flagOutC = true;
		}
		else rigid[i].flagOutC = false;

		float ng;
		float a = rigid[i].vSize.x / 2.0 + vesselC.thickness / 2.0;
		//ʂƂ̏Փ
		if(fabs(v_pos.z) < vesselC.height/2.0)
		{
			if(v_pos.magnitudeXY() < vesselC.radius)
			{ //	
				depth = v_pos.magnitudeXY() + a - vesselC.radius;
				if(depth > 0.0) 
				{
					v_normal = v_pos.normXY2();
					v_vel -= (e + 1.0) * vDot(v_vel, v_normal) * v_normal;
					v_vel -= depth * cSpring * v_normal * dt /  rigid[i].mass;
					v_pos -= (depth+dd) * v_normal;//߂荞񂾕ǂ
					//C̉e
					ng = vDot(v_normal, v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * (v_vel- v_velT).norm2() * dt;
				}
			}
			else
			{ //O	
					depth = -v_pos.magnitudeXY() + a + vesselC.radius;
					if(depth > 0.0) 
					{
					v_normal = v_pos.normXY2();
					v_normal.reverse();
					v_vel += -(e + 1.0) * vDot(v_vel, v_normal) * v_normal;
					v_vel -= depth * cSpring * v_normal * dt /  rigid[i].mass;
					v_pos -= (depth+dd) * v_normal;//߂荞񂾕ǂ
					//C̉e
					ng = vDot(v_normal, v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * (v_vel-v_velT).norm2() * dt;
				}
			}
		}

		if(v_pos.magnitudeXY() < vesselC.radius)
		{
			//ƏՓ
			if(v_pos.z > -vesselC.height/2.0)
			{
				//
				depth = -vesselC.height/2.0 - v_pos.z + a;
				if(depth>0.0)
				{
					v_vel.z *= -e ;//xz𔽓]
					v_vel.z += depth * cSpring * dt / rigid[i].mass;
					v_pos.z += depth+dd;//߂荞񂾕ǂ
					//C̉eixyʁj
					ng = vDot(CVector(0.0, 0.0, -1.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * (v_vel-v_velT).normXY2() * dt;
				}
			}

			else//O
			{
				depth = vesselC.height/2.0 + v_pos.z + a;
				if(depth > 0.0)
				{
					v_vel.z *= -e ;//xz𔽓]
					v_vel.z -= depth * cSpring * dt / rigid[i].mass;
					v_pos.z -= depth+dd;//߂荞񂾕ǂ
					//C̉eixyʁj
					ng = vDot(CVector(0.0, 0.0, 1.0), v_accelG);
					if(ng > 0.0) v_vel -= muK * ng * (v_vel-v_velT).normXY2() * dt;
				}
			}

			//Ƃ̏Փ
			if(vesselC.flagCover) 
			{
				if(v_pos.z < vesselC.height/2.0)
				{
					//
					depth = v_pos.z + a - vesselC.height/2.0;
					if(depth > 0.0) 
					{
						v_vel.z *= -e;//xz𔽓]
						v_vel.z -= depth * cSpring * dt / rigid[i].mass;
						v_pos.z -= depth+dd;//߂荞񂾕ǂ
						//C̉eixyʁj
						ng = vDot(CVector(0.0, 0.0, 1.0), v_accelG);
						if(ng > 0.0) v_vel -= muK * ng * (v_vel - v_velT).normXY2() * dt;
					}
				}
				else
				{
					//O
					depth = -v_pos.z + a + vesselC.height/2.0;
					if(depth > 0.0)
					{
						v_vel.z *= -e;//xz𔽓]
						v_vel.z += depth * cSpring * dt / rigid[i].mass;
						v_pos.z += depth+dd;//߂荞񂾕ǂ
						//C̉eixyʁj
						ng = vDot(CVector(0.0, 0.0, -1.0), v_accelG);
						if(ng > 0.0) v_vel -= muK * ng * (v_vel - v_velT).normXY2() * dt;
					}
				}
			}
		}
		//̐EWnɖ߂
		rigid[i].vPos = qvRotate(vesselC.q, v_pos) + vesselC.vPos;
		rigid[i].vVelocity = qvRotate(vesselC.q, v_vel);
	}
}
