
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform sampler2DRect samplerCol;
uniform int texWidth, texHeight;
uniform float GM;
uniform float bulgeRadius;
uniform float dt;
uniform float time;
varying vec2 texPos;

void main(void)
{
	vec4 position, position0, velocity, color;
	int i, j;
	float dist;
	vec3 omega;
	vec3 accel = vec3(0.0, 0.0, 0.0);
	position = texture2DRect(samplerPos, texPos);	
	velocity = texture2DRect(samplerVel, texPos);
	color = texture2DRect(samplerCol, texPos);
	
	if(texPos.y < float(texHeight/2))
	{
		//No=0(Q)
		position0 = texture2DRect(samplerPos, vec2(0.0, 0.0));//Sʒu
		//͒S̋
		dist = length(position.xyz - position0.xyz);
		if(color.a == -1.0)//halö͎ԍ
		{
			if(time >= position.w) 
				accel.xyz -= normalize(position.xyz - position0.xyz) * GM / dist;
		}
		else
		{
			if(color.a == 1.0) accel.xyz -= normalize(position.xyz - position0.xyz) * (GM/1000.0) / dist;//Qrq			
			else               accel.xyz -= normalize(position.xyz - position0.xyz) * GM / dist;//ʂ̗q
		}
		velocity.xyz += accel.xyz * dt;
	}
	else
	{
		//No=1(_Q)
		position0 = texture2DRect(samplerPos, vec2(0.0, float(texHeight/2)));//Sʒu
		vec3 axis = texture2DRect(samplerCol, vec2(0.0, float(texHeight/2))).xyz;//]
		//͒S̋
		dist = length(position.xyz - position0.xyz);

		if(color.a == -1.0)//halö͎ԍ
		{
			if(time >= position.w) 
			{
				accel.xyz -= normalize(position.xyz - position0.xyz) * GM / dist;
				velocity.xyz += accel.xyz * dt;
			}		
		}
		else
		{
			if(dist > bulgeRadius)//disk
			{
				if(color.a == 1.0) accel.xyz -= normalize(position.xyz - position0.xyz) * (GM/1000.0) / dist;//Qrq
				else               accel.xyz -= normalize(position.xyz - position0.xyz) * (GM) / dist;//ʂ̗q
				velocity.xyz += accel.xyz * dt;		
			}

			else//bulge
			{
				if(color.a == 1.0)//_\̗q
				{
					omega = axis * sqrt(GM/1000.0) / bulgeRadius;
					velocity.xyz = dist * cross(omega, normalize(position.xyz - position0.xyz));
				}
				else
				{
				  accel.xyz -= normalize(position.xyz - position0.xyz) * GM / dist;//ʂ̗q
				  velocity.xyz += accel.xyz * dt;
				}		
			}
		}
	}	
	gl_FragColor = velocity;
}
