
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform int texWidth;
uniform int texHeight;
uniform float G_CONST;//d͒萔
uniform float distEffect;
uniform float constMR;
uniform float dt;
varying vec2 texPos;

void collision(in vec4 position, inout vec4 velocity, in vec4 velTarget);

void main(void)
{
	vec4 position, velocity, posTarget, velTarget;
	int i, j;
	float dist, radA, radB;
	vec2 accel = vec2(0.0, 0.0);

	position = texture2DRect(samplerPos, texPos);	
	velocity = texture2DRect(samplerVel, texPos);

	//zɑ΂
	if(texPos.x != 0.0 || texPos.y != 0.0)//zg
	{
		dist = length(position.xy);
		velTarget = texture2DRect(samplerVel, vec2(0.0, 0.0));//zʂ𓾂
		accel -= normalize(position).xy * G_CONST * velTarget.w / (dist * dist);//w
	}

	radA = constMR * pow(velocity.w , 0.333);
	
	for(j = 0; j < texHeight; j++)//ΏۂƂȂWԍicj
	for(i = 0; i < texWidth; i++) //ΏۂƂȂWԍij
	{
		if(float(i) == texPos.x && float(j) == texPos.y) continue;//g
		posTarget = texture2DRect(samplerPos, vec2(float(i), float(j)));
		velTarget = texture2DRect(samplerVel, vec2(float(i), float(j)));
		if(velTarget.w == 0.0) continue;//ōς
		dist = distance(position.xy, posTarget.xy);
		
		if(dist > distEffect) continue;

		radB = constMR * pow(velTarget.w , 0.333);
		if(dist < radA + radB ) collision(position, velocity, velTarget);
		else
		{ 
			if(float(i) != 0.0 && float(j) != 0.0) //sun(ǉς݁j
				accel += normalize(posTarget - position).xy * G_CONST * velTarget.w / (dist * dist);
		}

	}
	if(velocity.w != 0.0) velocity.xy += accel * dt;//velocity.w=0.0Ȃ
	if(texPos.x == 0.0 && texPos.y == 0.0) velocity.xy = vec2(0.0, 0.0);//sun

	gl_FragColor = velocity;
}

void collision(in vec4 position, inout vec4 velocity, in vec4 velTarget)
{
	if(velocity.w > velTarget.w)//w͎
	{
		velocity.xy = (velocity.w * velocity.xy + velTarget.w * velTarget.xy) / (velocity.w + velTarget.w);
	  velocity.w += velTarget.w;//
	}
	else
	{
		velocity = vec4(0.0, 0.0, 0.0, 0.0);//velocity.w͎ʁiՓ˃tOɂpj
	} 	
}
