
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
uniform sampler2DRect samplerVel;
uniform sampler2DRect samplerCell;
uniform int texWidth;
uniform int texHeight;
uniform float widthCell;
uniform float minX, maxX, minY, maxY;
uniform float G_CONST;//d͒萔
uniform float constMR;
uniform float dt;
varying vec2 texPos;

int	texCellX = int((maxX - minX) / widthCell);//Z̉
int	texCellY = int((maxY - minY) / widthCell);//Z̏c

void searchTarget(in vec4 position, inout vec4 velocity, inout vec2 accel);
void collision(in vec4 position, inout vec4 velocity, in int Nij, inout vec2 accel);

void main(void)
{
	vec4 position, position0, velocity, velocity0;
	float dist;
	vec2 accel = vec2(0.0, 0.0);

	//ڗq̈ʒuƑx
	position = texture2DRect(samplerPos, texPos);	
	velocity = texture2DRect(samplerVel, texPos);	
	//z̈ʒuƑx
	position0 = texture2DRect(samplerPos, vec2(0.0, 0.0));	
	velocity0 = texture2DRect(samplerVel, vec2(0.0, 0.0));

	//z͂ɂSx
	if(texPos.x != 0.0 || texPos.y != 0.0)
	{
		dist = distance(position.xy, position0.xy);
		accel = normalize(position0.xy - position.xy) * G_CONST * velocity0.w / (dist * dist);
	}
	searchTarget(position, velocity, accel);

	if(velocity.w != 0.0) velocity.xy += accel * dt;
	
	if(texPos.x == 0.0 && texPos.y == 0.0) velocity.xy = vec2(0.0, 0.0);//z͒SɌŒ
	  
	gl_FragColor = velocity;
}
//-------------------------------------------------------
void searchTarget(in vec4 position, inout vec4 velocity, inout vec2 accel)
{
	//̓Z̗qT
	int ic, jc, im, ip, jm, jp, xc, yc, Nij;
	
	//̗q݂Zʒu
	xc = int((position.x - minX) / widthCell);
	yc = int((position.y - minY) / widthCell);
	int d = 1;

	im = xc - d;// 
	if(im < 0) im = 0;
	ip = xc + d;//E
	if(ip >= texCellX) ip = texCellX-1;
	jm = yc - d;//
	if(jm < 0) jm = 0;
	jp = yc + d;//
	if(jp >= texCellY) jp = texCellY-1;
	
	vec4 cellInfo;
	for(jc = jm; jc <= jp; jc ++)
		for(ic = im; ic <= ip; ic ++)
		{		
			cellInfo = texture2DRect(samplerCell, vec2(float(ic), float(jc)));
			//Z(ic,jc)ɑ݂闱qԍ
			Nij = int(cellInfo.r);
			if(Nij < 0) continue;//݂
			collision(position, velocity, Nij, accel);
			
			Nij = int(cellInfo.g);
			if(Nij < 0) continue;//݂
			collision(position, velocity, Nij, accel);
			
			Nij = int(cellInfo.b);
			if(Nij < 0) continue;//݂
			collision(position, velocity, Nij, accel);
			
			Nij = int(cellInfo.a);
			if(Nij < 0) continue;//݂
			collision(position, velocity, Nij, accel);
		}
}
//---------------------------------------------------------------------------------
void collision(in vec4 position, inout vec4 velocity, in int Nij, inout vec2 accel)
{
	int i, j;
	float dist, radA, radB;
	
	//qԍNijx,y̔ԍʒu
	j = Nij / texWidth;
	i = Nij - j * texWidth;
	
	if(float(i) == texPos.x && float(j) == texPos.y) return;//q

	vec4 posTarget = texture2DRect(samplerPos, vec2(float(i), float(j)));
	vec4 velTarget = texture2DRect(samplerVel, vec2(float(i), float(j)));
	
	if(velTarget.w == 0.0) return;//ōς
	dist = distance(position.xy, posTarget.xy);
	
	//ʂ1/3ɔႵa
	radA = constMR * pow(velocity.w , 0.333);//ڗq
	radB = constMR * pow(velTarget.w , 0.333);//Ώۗq
	
	if(dist > radA + radB)
	{ 
		if(i != 0 || j != 0)//z̈͂͒ǉς
			accel += normalize(posTarget.xy - position.xy) * G_CONST * velTarget.w / (dist * dist);
	}
	else //Փ
	{
		if(velocity.w > velTarget.w)//w͎
		{
			velocity.xy = (velocity.w * velocity.xy + velTarget.w * velTarget.xy) / (velocity.w + velTarget.w);
			velocity.w += velTarget.w;
		}
		else
		{
			velocity = vec4(0.0, 0.0, 0.0, 0.0);//ʂ0iŃtOj
		}
	} 
}

