
//collisionSolar.h
//V̂̂̂̕Ɖ肵Փˉ

void collisionResponse(int i, int j, float dt);
//float checkCollision(int i, int j, CVector &vNormal);

void collision(float dt)
{
	int i, j;

	for(i = 0; i < numRigid0; i++)
	{   
		for(j = i+1; j < numRigid0; j++)
		{
			//Eŗ\
			float d = vDist2(rigid[i].vPos, rigid[j].vPos);//2拗
			float a = rigid[i].boundingR + rigid[j].boundingR;
			if(d > a*a) continue;
			collisionResponse(i, j, dt);

		}
	}
}
//--------------------------------------------------------------------------
void collisionResponse(int i, int j, float dt)
{
  float rikiseki;
  float vn1, vn2;//@̑傫
  float muc,B, m1, m2;
  CVector vVelocityP1, vVelocityP2;//x
  CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
  CVector vTangential;//ڐ
  CVector vDir, vA1, vA2, vRg1, vRg2, vPos1, vPos2;

	float depth = rigid[i].collisionSphereWithSphere(rigid[j], vNormal);
	if(depth < 0.0) return;

	rigid[i].vForce = CVector();
	rigid[i].vTorque = CVector();
	rigid[j].vForce = CVector();
	rigid[j].vTorque = CVector();

  vRg1 = rigid[i].vGravityToPoint;
  vRg2 = rigid[j].vGravityToPoint;
  m1 = rigid[i].mass;
  m2 = rigid[j].mass;

  vVelocityP1 = rigid[i].vVelocity + vCross(rigid[i].vOmega, vRg1);
  vn1 = vDot(vVelocityP1, vNormal);
  vVelocityP2 = rigid[j].vVelocity + vCross(rigid[j].vOmega, vRg2);
  vn2 = vDot(vVelocityP2, vNormal);

  //Փˉ
  vTangential = vCross( vNormal, vCross((vVelocityP1 - vVelocityP2), vNormal));
  vTangential.norm();
  //͐
  rikiseki = - (e + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0f/m2
          + vDot(vNormal , vCross((rigid[i].mInertiaInverse * vCross(vRg1, vNormal)), vRg1))
          + vDot(vNormal , vCross((rigid[j].mInertiaInverse * vCross(vRg2, vNormal)), vRg2)));
	//͂̑a
	rigid[i].vForce += (vNormal) * rikiseki / dt;
	rigid[j].vForce -= (vNormal) * rikiseki / dt;
	//͂̃[gigNj̑a
	rigid[i].vTorque += vCross(vRg1, vNormal) * rikiseki / dt;
	rigid[j].vTorque -= vCross(vRg2, vNormal) * rikiseki / dt;

	//Cl
  vA1 = vCross(((rigid[i].mInertiaInverse * vCross(vRg1, vTangential))) , vRg1);
  vA2 = vCross(((rigid[j].mInertiaInverse * vCross(vRg2, vTangential))) , vRg2);
  B = - vDot(vTangential, (vVelocityP1-vVelocityP2)) / (1.0f/m1+1.0f/m2+ vDot(vTangential,(vA1+vA2)));
	muc = fabs(B / rikiseki);
	if(muK >= muc)
	{
		rigid[i].vForce +=  vTangential* B / dt;
		rigid[i].vTorque += vCross(vRg1, vTangential) * B / dt;
		rigid[j].vForce -=  vTangential* B / dt;
		rigid[j].vTorque -= vCross(vRg2, vTangential) * B / dt;
	}
	else
	{
		rigid[i].vForce +=  muK * (rikiseki / dt) * vTangential;
		rigid[i].vTorque += vCross(vRg1, vTangential) * muK * rikiseki / dt;
		rigid[j].vForce -=  muK * (rikiseki / dt) * vTangential;
		rigid[j].vTorque -= vCross(vRg2, vTangential) * muK * rikiseki / dt;
	}
	//Փ˔莞ɂ߂荞񂾕
	rigid[i].vPos -= (depth+0.01) * vNormal;//0.01͕mɂ邽				
	rigid[j].vPos += (depth+0.01) * vNormal;

  //ʒu]px̍XV
	// iԖڂ̍
	rigid[i].vAccel = rigid[i].vForce / m1;    //x
	rigid[i].vVelocity += rigid[i].vAccel * dt;//x
	rigid[i].vPos += rigid[i].vVelocity * dt;  //ʒu
	
	rigid[i].vAlpha = rigid[i].mInertiaInverse * rigid[i].vTorque;//px̍XV
	rigid[i].vOmega += rigid[i].vAlpha * dt;   //px

	rigid[i].q += 0.5 * rigid[i].vOmega * rigid[i].q * dt;
	rigid[i].q.norm();
	rigid[i].angle = 2.0 * acos(rigid[i].q.s);
	rigid[i].vAxis = rigid[i].q.v.norm2();

	// jԂ̍
	rigid[j].vAccel = rigid[j].vForce / m2;
	rigid[j].vVelocity += rigid[j].vAccel * dt;
	rigid[j].vPos += rigid[j].vVelocity * dt;
	rigid[j].vAlpha = rigid[j].mInertiaInverse * rigid[j].vTorque;
	rigid[j].vOmega += rigid[j].vAlpha * dt;

	rigid[j].q += 0.5 * rigid[j].vOmega * rigid[j].q * dt;
	rigid[j].q.norm();
	rigid[j].angle = 2.0 * acos(rigid[j].q.s);
	rigid[j].vAxis = rigid[j].q.v.norm2();

	rigid[i].collision = j;
	rigid[j].collision = i;
}
