//rigidSolar.h
#include "../../parametersSolar.h"

//znV~[Vp

#define RIGID_NUM_MAX 500
#define MAX_VERTEX 100//ʑ̂̒_ 
enum ShiftMode {TRANSLATE, ROTATION, LIGHT, VELOCITY};
ShiftMode shiftMode = TRANSLATE;
enum CoordMode { INERTIAL, OBJECT};
CoordMode coordMode = INERTIAL;

int numRigid0 = 2;
int	numMinor = 100;//f
int	numPlanet = 8;
int	numSatellite = 3;
int numRigid = 213;//Xg{܂߂

//-------------------------------------------------------------------------
class CRigid{
public:
	//ޕϐ
	Kind kind;    //CRigid̎
	Color color;  //F
	CVector vSize;//TCY
	CVector vPos;//ʒu
	CVector vEuler;//IC[p(p̏ݒ,deg)
	CVector vAxis; //]
	float angle;   //]px(rad)
	float radius;  //ŉƂ̔a,f̋Oa
	float period;  //ŉƂ̎Cf̌]
	float phase0;  //ŉƂ̏ʑCf̏ʒu߂ʑ

	//^V~[Vp
	float mass;        //(Kg)
	CVector vForce;    //O(Newton)
	CVector vForce0;   //O͏l
	CVector vTorque;   //͂̃[gigN,Newton/mj
	CVector vAccel;    //x(m/s^2)
	CVector vVelocity; //x(m/s)
	CVector vOmega;    //px(rad/s)
	CVector vAlpha;    //px(rad/s^2)
	CVector vGravityToPoint;//dSՓ˓_܂ł̃xNg
	CMatrix mInertia; //[g̃e\
	CMatrix mInertiaInverse;
	CQuaternion q;
    
	CVector vP[MAX_VERTEX], vP0[MAX_VERTEX];//ȊO̒_W
  CVector vNormalFacet[6];//̖̂ʂ̖@xNg

	int nSlice;//ȉ~,~,ȉ~̌ox
	int nStack;//ȉ~,~,ȉ~̈ܓx
	int nRing, nSide;//g[X
	float eps1, eps2;//2Ȗ
	int numVertex;//ȊȎʑ̂̒_
	int numEdge;
	
	float boundingR;//E̔a
	int select;
	int collision;
	int vanish;

	//ފ֐
	CRigid();  //RXgN^
	~CRigid(); //fXgN^
	void draw();
	void ready(void);
	void attraction(float dt);
	float collisionSphereWithSphere(CRigid& rigid, CVector& vNormal);
private:
	void calcMomentOfInertia();
};
CRigid rigid[RIGID_NUM_MAX];

//--------------------------------------------------
CRigid::CRigid()
{
	kind = SPHERE;
	color = WHITE;
  vSize = CVector(1.0, 1.0, 1.0);
  vPos = CVector();
	vAccel = CVector();
	vForce = vForce0 = CVector();
	vVelocity = CVector();
	vOmega = CVector();//px(rad)
	vAlpha = CVector();
	vEuler = CVector();
	q = CQuaternion();

	mass = 1.0;
	select = 0;
	vanish = 0;
	collision = -1;
}

//--------------------------------------------------
CRigid::~CRigid()
{
}
//---------------------------------------------------------
void CRigid::draw()
{
	glPushMatrix();
  
	//݈ʒu
	glTranslatef(vPos.x - worldX, vPos.y - worldY, vPos.z);//sړ

	//]
	if(q.s > 1.0) q.s = 1.0;
	if(q.s < -1.0) q.s = -1.0;
	angle = 2.0 * acos(q.s);//[rad]
	vAxis = q.v.norm2();
  glRotatef(angle * qq, vAxis.x, vAxis.y, vAxis.z);//]pdegɕϊ

	//̂̃}eA
  static float white0[] = { 0.9, 0.9, 0.9, 1.0};//I
  static float specular[]= { 0.8, 0.8, 0.8, 1.0};
	if(color == RED) glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red);
	if(color == GREEN) glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, green);
	if(color == BLUE) glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue);
	if(color == YELLOW) glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow);
	if(color == CYAN) glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, cyan);
	if(color == MAGENTA) glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, magenta);
	if(color == WHITE) glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, white);

	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS, 20.0);

	//XP[O
	glScalef(vSize.x, vSize.y, vSize.z);

	//޼ުĂ̕`
	if(select==1)
	{//Îtexture`
		if(kind == SPHERE || kind == ELLIPSOID) glCallList(sphereTex);
		else if(kind == CUBE) glCallList(cubeTex);
		else if(kind == CYLINDER) glCallList(cylinderTex);
		else if(kind == BOX) glCallList(boxTex);
		else if(kind == COLUMN) glCallList(columnTex);
		else if(kind == TORUS) glCallList(torusTex);
		else if(kind == CONE) glCallList(coneTex);
		else if(kind == PYRAMID) glCallList(pyramidTex);
	}
	else
	{//ʏ
		if(kind == SPHERE || kind == ELLIPSOID) glCallList(sphere);
		else if(kind == CUBE) glCallList(cube);
		else if(kind == CYLINDER) glCallList(cylinder);
		else if(kind == BOX) glCallList(box);
		else if(kind == COLUMN) glCallList(column);
		else if(kind == TORUS) glCallList(torus);
		else if(kind == CONE) glCallList(cone);
		else if(kind == PYRAMID) glCallList(pyramid);
	}
	glPopMatrix();
}
//---------------------------------------------------------
void CRigid::ready()
{
	calcMomentOfInertia();
}

//--------------------------------------------------------------------------------
void CRigid::attraction(float dt)
{	//͂^̂̉^
	vPos.z = 0.0;
	vVelocity.z = 0.0;

	vVelocity += vAccel * dt;
	vPos += vVelocity * dt;

	q += 0.5 * vOmega * q * dt;
	q.norm();
}
//-----------------------------------------------------------------------------
//m
float CRigid::collisionSphereWithSphere(CRigid& rigid, CVector& vNormal)
{
	vNormal = vPos >> rigid.vPos;//1狅2֌Pʖ@xNg
	//dSՓ˓_܂ł̃xNg
	vGravityToPoint = (vSize.x/2.0) * vNormal;
	rigid.vGravityToPoint = (rigid.vSize.x/2.0) * vNormal;
	rigid.vGravityToPoint.reverse();
	float depth = (vSize.x + rigid.vSize.x) / 2.0 - vDist(vPos, rigid.vPos);
	return depth;//m̏ꍇCKՓ
}
//------------------------------------------------------------------------------
void CRigid::calcMomentOfInertia()
{
  float Ixx, Iyy, Izz;
  if(kind == SPHERE)
  {
    Ixx = Iyy = Izz = vSize.x * vSize.x * mass / 10.0; //vSize͒a
  }

  //[g ̃e\
  mInertia = CMatrix(Ixx, 0.0, 0.0,
                     0.0, Iyy, 0.0,
                     0.0, 0.0, Izz );
  mInertiaInverse = mInertia.inverse();
}
