//vesselCylinder.h
#define MAX_SIDE 22
CVector vVelocityL;

//
//float lightPos[]  = {10.0, 10.0, 80.0, 1.0};//ʒu
//float lightPos0[] = {10.0, 10.0, 80.0, 1.0};//ʒu(l)

struct SideC
{
	CVector vPos0;//vesselS̑Έʒui{p
	CVector vPos;//vessel̕sړE]
	//CVector vSize;
	int kind;//ʂȂ1CEȂ0
	float phi;//]p
};

class CVesselCylinder
{
public:

	//CVector vSize;//TCY
	CVector vPos; //ʒu
	CVector vEuler;//IC[p(p̏ݒ,deg)
	CVector vAxis; //]
	CVector vAlpha;//px
	CVector vOmega;//px
	float omegaMax;
	float alphaMax;
	float alpha;
	float angle;  //]px(rad)
	CQuaternion q;
	int numSide ;//ȇʂƏC
	int numSide0;//ȇ
	SideC side[MAX_SIDE];
	int farNo[MAX_SIDE];
	float thickness;
	float width;//ʂ̕
	float height;//ʂ̍
	float radius;///̔a
	int mode;
	bool flagStop;
	bool flagClose;

	bool flagCover;
	float trans ;//x
	bool flagSelect;

	//ފ֐
	CVesselCylinder();  //RXgN^
	~CVesselCylinder(); //fXgN^
	void draw(CVector eye, bool flagShadow);
	void CalcShadowMat(double* mat);
	void drawShadow(CVector eye);
	void ready();
private:
	void getFarNo(CVector eye);
};
CVesselCylinder vesselC;

CVesselCylinder::CVesselCylinder()
{
	thickness =1.0;// 0.2;
	radius = 15.0;//10.0;
	height = 30.0;//ʂ̍
	flagCover = true;
  trans = 0.7;//x
	numSide = MAX_SIDE;//ȇʂƏC
	numSide0 = numSide - 2;//ȇ
	vPos = CVector(0.0, 0.0, 25.0);//Sʒu
	vAlpha = CVector();
	vOmega = CVector();
	vEuler = CVector();
	q = CQuaternion();
	mode = 0;
}

void CVesselCylinder::ready()
{
	float phi0 = 2.0 * M_PI / (float)numSide0;
	width = 2.1 * radius * sin(phi0 / 2.0);//ʂ̕(傫߂Ɂj
	for(int i = 0; i < numSide0; i++)
	{//
		side[i].phi = phi0 * (float)i + phi0 / 2.0;//rad
		side[i].vPos0 = CVector(cos(side[i].phi), sin(side[i].phi), 0.0) * radius;
		side[i].kind = 1;
	}
	side[numSide0].vPos0 = CVector(0.0, 0.0, -height/2.0);//
	side[numSide0+1].vPos0 = CVector(0.0, 0.0, height/2.0);//iWj
	side[numSide0].kind = side[numSide0+1].kind = 0; 
	vAlpha = CVector();
	vOmega = CVector();
  mode = 0;
	flagStop = false;
}

CVesselCylinder::~CVesselCylinder()
{
}

void CVesselCylinder::draw(CVector eye, bool flagShadow)
{
  float specular[]= { 0.8, 0.8, 0.8, 1.0};
	float diffuse[] = { 0.4, 0.4, 1.0, 1.0-trans};

	//ẽ}eA
	float shadowDiffuse[] =  {0.1, 0.1, 0.2, 0.3 * (1.0-trans)};//e̊gU
	//float shadowSpecular[] = {0.0, 0.0, 0.0, 0.5};//e̋ʌ

	getFarNo(eye);//_牓

	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 100.0);
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuse);
	}
	else
	{
//		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, shadowDiffuse);
	}

	glPushMatrix();
	//݈ʒu
	glTranslatef(vPos.x, vPos.y, vPos.z);//sړ

	//]
	if(q.s > 1.0) q.s = 1.0;
	if(q.s < -1.0) q.s = -1.0;
	float angle = 2.0 * acos(q.s);//[rad]
	CVector vAxis = q.v.norm2();
	glRotatef(angle * qq, vAxis.x, vAxis.y, vAxis.z);//]pdegɕϊ
	
	if(vesselC.flagCover) numSide = MAX_SIDE;
	else numSide = MAX_SIDE - 1;
	for(int i = 0; i < numSide; i++)
	{
		int k = farNo[i];
		glPushMatrix();
		glTranslatef(side[k].vPos0.x, side[k].vPos0.y, side[k].vPos0.z);
		
		if(side[k].kind == 1)//	
		{
			glRotatef(side[k].phi * qq, 0.0, 0.0, 1.0); 
			glScalef(thickness, width, height);
			glCallList(cube);
		}
		else//Ɖ
		{
			glScalef(2.02 * radius, 2.02 * radius, thickness);
			glCallList(cylinder);
		}
		glPopMatrix();
	}
	glPopMatrix();
}

void CVesselCylinder::CalcShadowMat(double* mat)
{
  double ex, ey, ez;//̕
  double a, b, c, d;//̖ʂ̃p[^
  double s; //objectS܂ł̋
  double x, y, z;

  x = lightPos[0] - vPos.x;
  y = lightPos[1] - vPos.y;
  z = lightPos[2] - vPos.z;

  //̕xNg
  s = sqrt(x * x + y * y + z * z);
  ex = x / s;
  ey = y / s;
  ez = z / s;

  //tA̕xNg(zj
  a = 0.0;
  b = 0.0;
  c = 1.0;
  d = -0.1; //tAƉe̊h
  //shadow matrix
  mat[0] = b * ey + c * ez;
  mat[1] = -a * ey;
  mat[2] = -a * ez;
  mat[3] = 0.0;
  mat[4] = -b * ex;
  mat[5] = a * ex + c * ez;
  mat[6] = -b * ez;
  mat[7] = 0.0;
  mat[8] = -c * ex;
  mat[9] = -c * ey;
  mat[10] = a * ex + b * ey;
  mat[11] = 0.0;
  mat[12] = -d * ex;
  mat[13] = -d * ey;
  mat[14] = -d * ez;
  mat[15] = a * ex + b * ey + c * ez;
}

void CVesselCylinder::drawShadow(CVector eye)
{
  //vZ͕sɑ΂e
  //޼ުĂƂɌ̕ςA^Iɓ_ɑ΂e
  double mat[16]; //es̗vf

  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

  glDepthMask(GL_FALSE);
	{
			CalcShadowMat(mat);
			glPushMatrix();
				glMultMatrixd(mat);//}gNX̏Z
				draw(eye, true);//޼ުĂ̕`
			glPopMatrix();
	}

  //e̕`I
  glDepthMask(GL_TRUE);
  glDisable(GL_BLEND);
}

void CVesselCylinder::getFarNo(CVector eye)
{
	int i, j;
	float farthest;

	float dist[MAX_SIDE];
	int mark[MAX_SIDE];//ς݂1Ƃ

	for(i = 0; i < numSide; i++)
	{
		side[i].vPos = qvRotate(q, side[i].vPos0) + vPos;
		dist[i] = vDist(side[i].vPos, eye);
		mark[i] = 0;
	}
	for(i = 0; i < numSide; i++)
	{
		farthest = 0.0;//dist[i];
		for(j = 0 ; j < numSide; j++)
		{
			if(mark[j] == 1) continue;//mς
			if(farthest < dist[j])
			{
				farNo[i] = j;
				farthest = dist[j];
			}
		}
		mark[farNo[i]] = 1;
	}
//for(i = 0; i < numSide; i++) printf("i = %d, farNo = %d, dist = %f \n", i, farNo[i], dist[i]);
}

